/********************************************/
/* Javascript für Drag&Drop                 */
/* wird verwendet in: index.php             */
/********************************************/

/*musik_objekt*/
//drag
$( ".musik_objekt_drag" ).draggable({ //musik draggable setzten
	revert: "invalid",
	helper: 'clone',
	appendTo: 'body',
	start: function( event, ui ) 
	{
		kontextmenu_hide();
		
	}
 });
 
 //click
 var musik_objekt_clickable = function (event) //Einblenden des musik objektes
 {	
	kontextmenu_hide();
	var index=$(this).attr("id").replace("musik_objekt", ""); 
	kontextmenu_show(musik_objekte[index], false);
 }

 
/*Musik Droppable*/
//init
$("#chor" ).droppable({ 
	accept: ".musik", 
	over: function(event, ui)
	{
		$(this).addClass("chor_hover");
	},
	out: function(event, ui)
	{
		$(this).removeClass("chor_hover");
	},
	 drop: function( event, ui ) 
	{
	   var element = $(ui.draggable).clone(); //Kopieren der gedraggten hintergrund Ojbektes
	   element.children().css("z-index", "100");
	   element.children().css("position", "absolute");
	  
	   element.css({marginLeft: 120, marginTop: -110}); //Ausrichten des Musikobjekts
	   element.appendTo(this); //Hinzufügen des Musikobjekts 
	   element.removeClass('musik_objekt_drag'); //Draggable deaktivieren
	   element.addClass('musik_objekt_clickable'); //Musik anlickbar machen
	   element.on('click', musik_objekt_clickable);
	   $(this).removeClass("chor_hover"); //Hovereffekt entfernen
	   $(this).droppable("disable"); //Platz droppable deaktivieren
	   
	   //Neues Musikobjekt erstellen
	   jQuery.data(element, "startzeit", hauptzeitleiste_wert);
	   jQuery.data(element, "endzeit", dauer);
	   jQuery.data(element, "art", "musik");
	   musik_objekte.push(element);
	   var index=musik_objekte.length-1;
	   element.attr("id","musik_objekt"+index); 
	   kontextmenu_show(element, true);
		
	}
	
});
 
 
/*hintergrund_objekte*/
//drag
$( ".hintergrund_objekt_drag" ).draggable({ //hintergrund_objekt draggable setzten
	revert: "invalid",
	helper: 'clone',
	appendTo: 'body',
	start: function( event, ui ) 
	{
		kontextmenu_hide();
		
	}
 });
 
 //click
 var hintergrund_objekt_clickable = function (event) //Einblenden des buehnen_objektenmenüs
 {
	
	kontextmenu_hide();
	var index=$(this).attr("id").replace("hintergrund_objekt", ""); 
	kontextmenu_show(hintergrund_objekte[index], false);
 } 
 
 
	
/*Hintergrund Droppable*/
//init
$("#hintergrund" ).droppable({ 
	accept: ".hintergrund", 
	over: function(event, ui)
	{
		$(this).addClass("hintergrund_hover");
	},
	out: function(event, ui)
	{
		$(this).removeClass("hintergrund_hover");
	},
	 drop: function( event, ui ) 
	{
		
	   var element = $(ui.draggable).clone(); //Kopieren der gedraggten hintergrund Ojbektes
	   element.children().css("width", "827px");
	   element.children().css("height", "157px");
	  
	   element.css({marginLeft: 0, marginTop: 0}); //Ausrichten des Hintergrunds
	   element.appendTo(this); //Hinzufügen des Hintergrundes 
	   element.removeClass('hintergrund_objekt_drag'); //Draggable deaktivieren
	   element.addClass('hintergrund_objekt_clickable'); //Hintergrund anlickbar machen
	   element.on('click', hintergrund_objekt_clickable);
	   $(this).removeClass("hintergrund_hover"); //Hovereffekt entfernen
	   $(this).droppable("disable"); //Platz droppable deaktivieren
	   
	   //Neues hintergrund_objekt erstellen
		jQuery.data(element, "startzeit", hauptzeitleiste_wert);
		jQuery.data(element, "endzeit", dauer);
		jQuery.data(element, "art", "hintergrund");
		
		hintergrund_objekte.push(element);	 
		var index=hintergrund_objekte.length-1;
		element.attr("id", "hintergrund_objekt"+index);
		kontextmenu_show(element, true);
	}
	
});

	

/*buehnen_objekte*/
//drag
$( ".buehnen_objekt_drag" ).draggable({ //buehnen_objekte draggable setzten
	revert: "invalid",
	helper: 'clone',
	appendTo: 'body',
	start: function( event, ui ) 
	{
		kontextmenu_hide();
		
		
	}
 });
 
 //click
 var buehnen_objekt_clickable = function (event) //Einblenden des buehnen_objektenmenüs
 {
	kontextmenu_hide();
	var index=$(this).attr("id").replace("buehnen_objekt", ""); 
	kontextmenu_show(buehnen_objekte[index], false);
 }
 
/*Platz Droppable*/
//init
$(".platz_droppable").droppable({ //Plätze droppable setzten
	accept: ".figur, .requisite",
	over: function(event, ui)
	{
		$(this).addClass($(this).attr('id')+"_hover");
		for (var i=0; i<=14; i++)
		{
			var help=('platz_'+i);
			if (help!=$(this).attr("id"))
			$('#platz_'+i).droppable("disable"); 
	
		}
		
		
	},
	out: function(event, ui)
	{
		$(this).removeClass($(this).attr('id')+"_hover");
		for (var i=0; i<=14; i++)
		{
			$('#platz_'+i).droppable("enable"); 
	
		}
		buehnen_update(hauptzeitleiste_wert);
	},
	drop: function( event, ui ) 
	{
	
	   for (var i=0; i<=14; i++)
	   {
			$('#platz_'+i).droppable("enable");
	   }
	   var element = $(ui.draggable).clone(); //Kopieren der gedraggten buehnen_objekt
	   //Größe des Elements bestimmen und Platzieren
	   element.children().css("width",  element.children().width());
	   element.children().css("height", element.children().height());
	   
	   element.css("width",  element.children().width());
	   element.css("height", element.children().height());
	   	   
	   var x = $(this).width()/2;
	   var help=element.children().width()/2;
	   x=x-help+"px";
	   var y= -element.children().height()+10;
	   var y=y+"px";
	   
	   
	   element.css({marginLeft: x, marginTop: y}); //Ausrichten der buehnen_objekt am Platz
	   element.appendTo(this); //Hinzufügen der buehnen_objekt zum Platz
	   element.removeClass('buehnen_objekt_drag'); //Draggable deaktivieren
	   element.addClass('buehnen_objekt_clickable'); //buehnen_objekt anlickbar machen
	   buehnen_objekt_droppable(element)
	   element.on('click', buehnen_objekt_clickable);
	   $(this).removeClass($(this).attr('id')+"_hover"); //Hovereffekt entfernen
	   $(this).droppable("disable"); //Platz droppable deaktivieren
	   
	   //Neues buehnen_objekt erstellen
		jQuery.data(element, "startzeit", hauptzeitleiste_wert);
		jQuery.data(element, "endzeit", dauer);
		jQuery.data(element, "platz", $(this).attr('id'));
		if (element.hasClass("figur"))
		jQuery.data(element, "art", "figur");
		else
		jQuery.data(element, "art", "requisite");
		
		buehnen_objekte.push(element);	 
		var index=buehnen_objekte.length-1;
		element.attr("id", "buehnen_objekt"+index);
		kontextmenu_show(element, true);
		buehnen_update(hauptzeitleiste_wert);
	}
});



/*bewegungen*/
//drag
$( ".bewegungen_objekt_drag" ).draggable({ //buehnen_objekte draggable setzten
	revert: "invalid",
	helper: 'clone',
	appendTo: 'body',
	start: function( event, ui ) 
	{
		kontextmenu_hide();		
	    $('.ui-draggable-dragging').children().removeClass("bewegung1");
		$('.ui-draggable-dragging').children().removeClass("bewegung2");
		$('.ui-draggable-dragging').children().removeClass("bewegung3");
		$('.ui-draggable-dragging').children().removeClass("bewegung4");
		$('.ui-draggable-dragging').children().removeClass("bewegung5");
		for (var i=0; i<buehnen_objekte.length;i++)
		$(buehnen_objekte[i]).droppable("enable");
		
		for (var i=0; i<bewegungen_objekte.length; i++)
		{
	
			$("#"+jQuery.data(bewegungen_objekte[i], "buehnen_objekt")).droppable("disable");
			
		}
		
		
	}
 });
 
 /*dialoge*/
//drag
$( ".dialog_objekt_drag" ).draggable({ //dialoge draggable setzten
	revert: "invalid",
	helper: 'clone',
	appendTo: 'body',
	start: function( event, ui ) 
	{
		kontextmenu_hide();	
		for (var i=0; i<buehnen_objekte.length;i++)
		$(buehnen_objekte[i]).droppable("enable");

		for (var i=0; i<dialog_objekte.length; i++)
		{
	
			$("#"+jQuery.data(dialog_objekte[i], "buehnen_objekt")).droppable("disable");
			
		}	
		
	}
	
 });
 
 
/*Bühnen Obejtk Droppable*/
//init
function buehnen_objekt_droppable(objekt){
objekt.droppable({ //Plätze droppable setzten
	accept: ".bewegung, .dialog",
	over: function(event, ui)
	{
		
		if ($(ui.draggable).attr("id").search("bewegung")>=0)
		{
			
				var classname=$('.ui-draggable-dragging').children().attr("id");
				$(this).children().addClass(classname);
				var index=$(this).attr("id").replace("buehnen_objekt", "");
				var platz= jQuery.data(buehnen_objekte[index],"platz");
				$('.'+platz).addClass(platz+'_active');
			
		}
		else
		{
				var index=$(this).attr("id").replace("buehnen_objekt", "");
				var platz= jQuery.data(buehnen_objekte[index],"platz");
				$('.'+platz).addClass(platz+'_active');
			 
		}

	},
	out: function(event, ui)
	{
		
		if ($(ui.draggable).attr("id").search("bewegung")>=0)
		{
			var classname=$('.ui-draggable-dragging').children().attr("id");
			$(this).children().removeClass(classname);
			 var index=$(this).attr("id").replace("buehnen_objekt", "");
			 var platz= jQuery.data(buehnen_objekte[index],"platz");
			 $('.'+platz).removeClass(platz+'_active');
		}
		else
		{
			 
			 var index=$(this).attr("id").replace("buehnen_objekt", "");
			 var platz= jQuery.data(buehnen_objekte[index],"platz");
			 $('.'+platz).removeClass(platz+'_active');
		}

	},
	drop: function( event, ui ) 
	{
		
	   element=$(ui.draggable).clone().insertAfter("#"+$(this).attr("id")+":last");
	   if ($(element).attr("id").search("bewegung")>=0)
	   {
			   var index=$(this).attr("id").replace("buehnen_objekt", ""); 
			   var startzeit=jQuery.data(buehnen_objekte[index], "startzeit");	
			   var endzeit=jQuery.data(buehnen_objekte[index], "endzeit");	
		
			   var bewegung=$(element).attr("id");
			   //Größe des Elements bestimmen und Platzieren
			  
			   element.css("display","none");
				   
			   
			   //Neues buehnen_objekt erstellen
				jQuery.data(element, "startzeit", startzeit);
				jQuery.data(element, "endzeit", endzeit);
				jQuery.data(element, "art", bewegung);
				jQuery.data(element, "buehnen_objekt", $(this).attr('id'));
				
				bewegungen_objekte.push(element);	 
				var index1=bewegungen_objekte.length-1;
				element.attr("id", "bewegung_objekt"+index1);
				
				kontextmenu_show(buehnen_objekte[index], true, "bewegung");
	   }
	   else
	   {
		   var index=$(this).attr("id").replace("buehnen_objekt", ""); 
		   var startzeit=jQuery.data(buehnen_objekte[index], "startzeit");	
		   var endzeit=jQuery.data(buehnen_objekte[index], "endzeit");	
	
	       var position=parseInt(element.prev().css("margin-left").replace("px",""));
		   var x=position+element.prev().width()-30+"px";
		  
		   
		   var y= -element.prev().height();
		   var y=y+"px";
		   element.css({marginLeft: x, marginTop: y});
		   element.children().css("width", "30px");

		   
		   //Neues buehnen_objekt erstellen
			jQuery.data(element, "startzeit", startzeit);
			jQuery.data(element, "endzeit", endzeit);
			jQuery.data(element, "text", "");
			var art=$(element).children().attr("src").indexOf("maennlich");
			if (art>-1)
			art="maennlich";
			else
			art="weiblich";
			jQuery.data(element, "art", art);
			jQuery.data(element, "buehnen_objekt", $(this).attr('id'));
						
			dialog_objekte.push(element);	 
			var index1=dialog_objekte.length-1;
			element.attr("id", "dialog_objekt"+index1);
			
			
			kontextmenu_show(buehnen_objekte[index], true, "dialog");
	    }
		
	}
});
}

 
